<?php
/*
Plugin Name: Scrip Datafile Form
Plugin URI: http://rinaldo.net/projects/scrip-plugin
Description: Insert scrip order form based on datafile using shortcode
Version: 1.0.0
Date: 07 May 2018
Author: Bery Rinaldo <bery@rinaldo.net>
Author URI: http://rinaldo.net/
*/

/*
	Copyright 2018 Bery Rinaldo

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License, version 2, as 
	published by the Free Software Foundation. A copy of the license is at
	http://www.gnu.org/licenses/gpl-2.0.html

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
*/

/*
Note: This plugin requires WordPress version 4.3.1 or higher.

Information about the Scrip Datafile Form plugin along with
instructions and examples can be found here:

http://rinaldo.net/projects/scrip-plugin

Shortcode format:

[scrip_datafile_form url="./some/datafile.txt" mailto="scrip@my-domain.org"]
*/

#define( 'WP_DEBUG', true );

if(isset($_POST) & !empty($_POST))
{
	//user posted variables
	$name = $_POST['Name'];
	$recipient = $_POST['Recipient'];
	$subject = $_POST['Subject'];
	$sender = $_POST['Sender'];
	$dphone = $_POST['DaytimePhone'];
	$ephone = $_POST['EveningPhone'];
	$message = $_POST['Form'];
	$captcha = $_POST['Captcha'];

	// there are a ton of other fields we do not care about, the Form field has what we need.

	if ($captcha == "2")
	{
		//php mailer variables
		$replyto = get_option('admin_email');
		$headers = 'From: '. $sender . "\r\n";
		$message .= "\nSent from: ".get_bloginfo('name')." ".get_site_url()."\n";

		$sent = mail($recipient, $subject, $message, $headers);
		if ($sent)
		{
			print "\n\nYour order has been sent to $recipient\n";
			sleep(5);
		}
	}
}

if( ! function_exists('bjrsu_scrip_datafile_form') )
{

	function bjrsu_scrip_datafile_form($content)
	{
		$bjrsu_content = $content;
		preg_match_all('!\[scrip_datafile_form[^\]].*url=\"(.*?)\".*mailto=\"(.*?)\"\]!is',$bjrsu_content,$bjrsu_matches);
		$bjrsu_nummatches = count($bjrsu_matches[0]);
		for( $bjrsu_i=0; $bjrsu_i<$bjrsu_nummatches; $bjrsu_i++ )
		{
			$bjrsu_replacement = bjrsu_scrip_datafile_form_file_to_html($bjrsu_matches[1][$bjrsu_i],$bjrsu_matches[2][$bjrsu_i]);
			$bjrsu_content = preg_replace('/'.preg_quote($bjrsu_matches[0][$bjrsu_i],'/').'/',$bjrsu_replacement,$bjrsu_content,1);
		}
		return $bjrsu_content;
	}
	add_filter( 'the_content', 'bjrsu_scrip_datafile_form', 9 );

	function bjrsu_obfuscate($str)
	{
		$ret_str = "<script>\n";
		$ret_str .= "document.write('";
		for ($i=0; $i < strlen($str); $i++)
		{
			$ordno = ord(substr($str,$i,1));
			if (rand(0,1) > 0)
			{
				$ret_str .= sprintf("\\\\x%02lx", $ordno);
			}
			else
			{
				$ret_str .= sprintf("\\\\%03lo", $ordno);
			}
		}
		$ret_str .= "');\n</script>\n";
		return $ret_str;
	}



	function bjrsu_scrip_datafile_form_file_to_html($datafileurl,$scripmail)
	{
		remove_filter( 'the_content', 'wpautop' );    # Needed to prevent extra <p> in Javascript and HTML below
		remove_filter( 'the_content', 'wptexturize'); # And to stop && from getting messed up sometimes

		$html_text =<<<HTMLTOP
<style>
.sectionwrap {
width:100%;
max-width:800px;
}
.sectionwrap a:link { font-weight:normal; color:#600;}
.sectionwrap a:visited { font-weight:normal; color:#800;}
.sectionwrap a:active{ font-weight:normal; color:#a00;}
.sectionwrap a:hover{ text-decoration:none; font-weight:normal; color:#00a;}

.forminput {
  padding:0px;
  margin:0px;
  min-width: 200px;
  width: 95%;
}

.greybutton {
        background-color:#eee;
        -moz-border-radius:6px;
        -webkit-border-radius:6px;
        border-radius:6px;
        border:1px solid #ccc;
        display:inline-block;
        color:#000;
        font-size:15px;
        font-weight:bold;
        padding:4px 10px;
        text-decoration:none;
}.greybutton:hover {
        background-color:#ddd;
}.greybutton:active {
        position:relative;
        top:1px;
}

.fixedtable {
  table-layout:fixed;
}
table, td, th {
  margin:0;
}
td {
  padding:0;
}
.myrightcol {
  float:right;
  width:45%;
  max-width:370px;
  margin:5px;
}
.myleftcol {
  float:left;
  width:45%;
  max-width:370px;
  margin:5px;
}
.itemname {
  text-align:left;
  font-size:0.8em;
  width:20%;
}
.itempct {
  text-align:right;
  font-size:0.7em;
  width:10%;
}
.itemdenom {
  text-align:right;
  font-size:0.7em;
  width:10%;
}
.itemqty {
  border:1px solid #800;
  text-align:right;
  font-size:0.8em;
  width:10%;
}
.itemqtyhdr {
  text-align:right;
  font-size:0.8em;
  width:10%;
}
.itemsub {
  text-align:right;
  font-size:0.7em;
  width:15%;
}
@media (max-width: 740px) {
.myrightcol {
  float:none;
  width:100%;
  min-width:100px;
  max-width:740px;
  margin:2px;
}
.myleftcol {
  float:none;
  width:100%;
  min-width:100px;
  max-width:740px;
  margin:2px;
}
}
</style>\n<script language="Javascript">
var clicksubmit = false;
var product = new Array();
HTMLTOP;

$rn = rand(1000,9999);
$ts = time();
$sid = "$ts" + "_" + "$rn";
$html_text .= "var sid = '$sid';\n";
$auto_detect_line_endings = TRUE;
$lines = file($datafileurl);
$count = 0;
foreach ($lines as $line_num => $line) {
  $line = preg_replace("/\r/","",$line);
  $line = preg_replace("/\n/","",$line);
  $line = preg_replace("/\"/","",$line);
  list($store,$percent,$amount,$junk) = preg_split ("/\t/", $line, 4);
  if ($store == "#") {
    if ($percent == "on-hand") {
      # nothing to do here...
    } elseif ($percent == "order-only") {
      $html_text .= "var on_hand_count = $count;\n";
    } elseif ($percent == "break") {
      $plusone = $count + 1;
      if ($amount == "on-hand") {
        $html_text .= "var break_on_hand = $plusone;\n";
      } else {
        $html_text .= "var break_order_only = $plusone;\n";
      }
    } else {
      $html_text .= "var version = \"$percent\";\n";
    }
  } else {
    $percent = preg_replace("/ /","",$percent);
    $amount = preg_replace("/\\\$/","",$amount);
    $amount = preg_replace("/ /","",$amount);
    $amount = preg_replace("/\//",",",$amount);
    if ($amount == "") {
      $amount = 0;
    }
    if (strstr($amount,",")) {
      $amtarray = preg_split ("/,/", $amount);
      $amtnum = count($amtarray);
      for ($l=0; $l<$amtnum; $l++) {
        $count = $count + 1;
        $html_text .= "product[$count] = new prodobj(\"$store\",\"$percent\",$amtarray[$l]);\n";
      }
    }
    else {
      $count = $count + 1;
      $html_text .= "product[$count] = new prodobj(\"$store\",\"$percent\",$amount);\n";
    }
  }
}
$html_text .= "var total_count = $count;\n";

$html_text .=<<<HTMLMID

function dc(num)
{
num = Math.floor(num*100+0.50000000001);
cents = num%100;
num = Math.floor(num/100).toString();
if (cents<10) {
  cents = "0" + cents;
}
return ('$' + num + '.' + cents);
}

function calculate()
{
  var total = 0;
  var exec;

  document.scripform.Form.value = version+"\\n\\n";
  document.scripform.Form.value = "Name: "+document.scripform.Name.value+"\\n";
  document.scripform.Form.value += "Email: "+document.scripform.Email.value+"\\n";
  if (document.scripform.DaytimePhone.value !== "") {
    document.scripform.Form.value += "DaytimePhone: "+document.scripform.DaytimePhone.value+"\\n";
  }
  if (document.scripform.EveningPhone.value !== "") {
    document.scripform.Form.value += "EveningPhone: "+document.scripform.EveningPhone.value+"\\n";
  }
  document.scripform.Form.value += "\\n";
  var special = "";
  for (i = 1; i <= total_count; i++) {
    if (i > on_hand_count) {
      special = " ** special order **";
    }
    if (product[i].percent !== "") {
      exec = 'var fqty = document.scripform.Quantity_'+sid+'_'+i+'.value';
      eval (exec);
      if (fqty !== "") {
        iqty = Math.floor(fqty);
        exec = 'document.scripform.Quantity_'+sid+'_'+i+'.value = iqty';
        eval (exec);
        exec = 'var subt = document.scripform.Quantity_'+sid+'_'+i+'.value * product['+i+'].amount';
        eval (exec);
        if (subt > 0) {
          exec = 'document.scripform.Subtotal_'+sid+'_'+i+'.value = dc(subt)';
          eval (exec);
          exec = 'document.scripform.Item_'+sid+'_'+i+'.value = product['+i+'].name';
          eval (exec);
          exec = 'document.scripform.Denomination_'+sid+'_'+i+'.value = dc(product['+i+'].amount)';
          eval (exec);
          document.scripform.Form.value += iqty+" "+product[i].name+" ("+dc(product[i].amount)+")" + special + "\\n";
        } else {
          clear_item(i);
        }
        total += subt;
      } else {
        clear_item(i);
      }
    }
  }
  document.scripform.Total.value = dc(total);
  document.scripform.Form.value += "\\nTotal "+dc(total)+"\\n";
  if (document.scripform.Comments.value !== "") {
    document.scripform.Form.value += "\\nComments:\\n"+document.scripform.Comments.value+"\\n";
  }
  document.scripform.Form.value += "--\\n";
}
function clear_item(idx)
{
  exec = 'document.scripform.Subtotal_'+sid+'_'+idx+'.value = ""';
  eval (exec);
  exec = 'document.scripform.Item_'+sid+'_'+idx+'.value = ""';
  eval (exec);
  exec = 'document.scripform.Denomination_'+sid+'_'+idx+'.value = ""';
  eval (exec);
}
function prodobj(name, percent, amount)
{
this.name = name;
this.percent = percent;
this.amount = amount;
return this;
}
function noenter()
{
  return !(window.event && window.event.keyCode == 13);
}
function validate()
{
  var issues = "";
  calculate();
  if (clicksubmit == false) {
    return false;
  }
  if (document.scripform.Name.value == "") {
    issues += "Please enter your name\\n";
  }
  if (document.scripform.Email.value == "") {
    issues += "Please enter your e-mail address\\n";
  } else {
    if ( document.scripform.Email.value.indexOf(".") < 1 ||
         document.scripform.Email.value.indexOf("@") < 1 ) {
      issues += "Please enter a valid e-mail address\\n";
    }
  }
  if (document.scripform.DaytimePhone.value == "" && 
      document.scripform.EveningPhone.value == "") {
    issues += "Please enter at least one phone number\\n";
  }
  if (issues !== "") {
    alert(issues);
    return false;
  }
}

function printfield(name,kind,tabi)
{
  document.write ('<input class="forminput" style="padding-left:0px;padding-right:0px;" onkeypress="return noenter()" type="'+kind+'" name="'+name+'" tabindex="'+tabi+'" size="10">');
}

function printcomment()
{
  document.write ('<textarea class="forminput" tabindex="32767" name="Comments" rows="3" cols="85"></textarea>');
}

function printsubmit()
{
  document.write ('<input class="greybutton" type="submit" onclick="clicksubmit = true" value="Submit Your Order">');
}

function printprod(start,end)
{
for (i = start; i < end; i++) {
  if (product[i].percent !== "") {
    ti = i + 4;
    document.write ('<tr>');
    document.write ('<td class="itemname" align="left">'+product[i].name+'<input type="hidden" name="Item_'+sid+'_'+i+'" value=""></td>');
    document.write ('<td class="itempct" align="right">'+product[i].percent+'</td>');
    document.write ('<td class="itemdenom" align="right">'+dc(product[i].amount)+'<input type="hidden" name="Denomination_'+sid+'_'+i+'" value=""></td>');
    document.write ('<td class="itemqty"><input style="padding:0;width:100%;text-align:right;" onkeypress="return noenter()" type="text" pattern="[0-9]*" name="Quantity_'+sid+'_'+i+'" tabindex="'+ti+'" size="5" onchange="calculate()"></td>');
    document.write ('<td class="itemsub"><input style="padding:0;font-size:10px;width:100%;text-align:right;" onkeypress="return noenter()" type="text" name="Subtotal_'+sid+'_'+i+'" onfocus="this.blur()"></td>');
  } else {
    document.write ('<tr bgcolor="#cccccc">');
    document.write ('<td class="itemname" align="left"><u>'+product[i].name+'</u></td>');
    document.write ('<td class="itempct" align="left">%</td><td class="itemdenom" align="center">Card</td><td class="itemqtyhdr" align="center">Qty</td><td class="itemsub" align="center">Total</td>');
  }
  document.write ('</tr>');
}
}
</script>
HTMLMID;



$html_text .= "<form name=\"scripform\" METHOD=\"POST\" onSubmit=\"return validate()\" ACTION=\"" . get_permalink() . "\">";

$noreply = preg_replace('/.*\@/',"no_reply@",$scripmail);

$touchy_fields =<<<TOUCHY
<input type="hidden" name="Recipient" value="$scripmail">
<input type="hidden" name="Sender" value="$noreply">
<input type="hidden" name="Captcha" value="2">
TOUCHY;

$html_text .= bjrsu_obfuscate($touchy_fields);

$html_text .=<<<HTMLEND

<input type="hidden" name="Subject" value="Scrip Order Form">

<input type="hidden" name="Form" value="">

<input type="hidden" name="Detailed Data Follows" value="--">

<div class="sectionwrap">

<div class="myleftcol">
<table class="fixedtable" width="98%" border="0" cellpadding="1" cellspacing="1"><tr><td>
<p>Your Name:</p>
<script language="Javascript">
printfield('Name','text','1');
</script>
<p>Your E-Mail Address:</p>
<script language="Javascript">
printfield('Email','email','2');
</script>
</td></tr></table>
</div>
<div class="myrightcol">
<table class="fixedtable" width="98%" border="0" cellpadding="1" cellspacing="1"><tr><td>
<p>Daytime Phone:</p>
<script language="Javascript">
printfield('DaytimePhone','tel','3');
</script>
<p>Evening Phone:</p>
<script language="Javascript">
printfield('EveningPhone','tel','4');
</script>
</td></tr></table>
</div>

</div>
<div class="clearfix">&nbsp;</div>
<div class="sectionwrap">

<div class="myleftcol">
<table class="fixedtable" width="98%" border="0" cellpadding="1" cellspacing="1">

<script language="Javascript">

printprod(1,break_on_hand);

</script>

</table>
</div>

<div class="myrightcol">
<table class="fixedtable" width="98%" border="0" cellpadding="1" cellspacing="1">

<script language="Javascript">
printprod(break_on_hand,on_hand_count+1);
</script>
<tr><td colspan="5" align="left">&nbsp;</td></tr>
<tr>
<td><input class="greybutton" type="reset" value="Reset"></td>
<td colspan="3" align="right">
<font size="3"><b>Grand Total . . .</b></font></td>
<td><input style="width:100%;padding:0;" onkeypress="return noenter()" autocomplete="off" type="text" name="Total" onfocus="this.blur()"></td>
</tr>
</table>
</div>

</div>
<div class="clearfix">&nbsp;</div>
<div class="sectionwrap">

<table border=0><tr><td>
Enter any comments, suggestions or special instructons for your order here:<br>

<script language="Javascript">
printcomment();
printsubmit();
</script>

</td></tr>
</table>

<table width="98%" border="0">
<tr><td bgcolor="#eeeeff">
<center>
<b>The following scrip is available by special order only.  Please allow extra time.</b>
</center>
</td></tr>
</table>

</div>
<div class="clearfix">&nbsp;</div>
<div class="sectionwrap">

<table width="99%" border="0">
<tr><td bgcolor="#eeeeff" valign="top">

<div class="myleftcol">
<table class="fixedtable" width="98%" border="0" cellpadding="1" cellspacing="1">

<script language="Javascript">

printprod(on_hand_count+1,break_order_only);

</script>

</table>
</div>

<div class="myrightcol">
<table class="fixedtable" width="98%" border="0" cellpadding="1" cellspacing="1">

<script language="Javascript">

printprod(break_order_only,total_count+1);

</script>

</table>

</td></tr>
</table>

</form>


<script language="Javascript">
  document.write ('<font size="1">Version: '+version+'</font><br>');
</script>

HTMLEND;
		return $html_text;
	}

} # if( ! function_exists('bjrsu_scrip_datafile_form') )

?>
